releases/20170422152552/releases/20170420035837/config/routes.rb
Rails.application.routes.draw do

  # Authentication
  get 'auth/:provider/callback', to: 'sessions#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'sessions#destroy', as: 'signout'
  resources :sessions, only: [:create, :destroy]

  # Homepages
  root 'home#logged_in'
  get 'authenticate', to: 'home#logged_out'
  resource :home, only: [:logged_in, :logged_out]

  # Admin
  get :admin, to: 'admin#home'

  # Users
  resources :users do
    put :organization_enable, :organization_disable
  end

  # User roles
  resources :user_roles

  # Roles
  resources :roles

  # Organizations
  resources :organizations

  # Late Plates
  resources :late_plates

  # Meals
  resources :meals

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

releases/20170422152552/releases/20170420035837/app/models/organization.rb
# == Schema Information
#
# Table name: organizations
#
#  id                   :integer          not null, primary key
#  full_name            :string           not null
#  abbreviation         :string           not null
#  school               :string           not null
#  address              :string           not null
#  organization_manager :integer
#  user_manager         :integer
#  kitchen_manager      :integer
#  house_manager        :integer
#  service_manager      :integer
#  scholarship_manager  :integer
#  created_at           :datetime         not null
#  updated_at           :datetime         not null
#

class Organization < ApplicationRecord
  # Helps our triggers
  include ActiveModel::Dirty

  has_one :user, foreign_key: 'organization_manager'

  def manager_name
    if self.organization_manager
      User.find(self.organization_manager).full_name
    else
      "Needs an Org Manager"
    end
  end

  def chapter_school
    "#{abbreviation} at #{school}"
  end

  def provisional_members
    users = []
    users.concat(get_provisional_members(self))
  end

  def get_provisional_members(user)
    members = []
    User.where(affiliated_organization: self.id).where.not(affiliated_organization: nil).where(enabled: false).each do |member|
      members.append(member)
    end

    members
  end

  def organization_members
    users = []
    users.concat(get_organization_members(self))
  end

  def get_organization_members(user)
    members = []
    User.where(affiliated_organization: self.id).where(enabled: true).order(:number).each do |member|
      members.append(member)
    end

    members
  end

  # Creates db triggers that are super helpful
  before_update :delete_organization_manager, :if => :organization_manager_changed?
  before_update :delete_user_manager, :if => :user_manager_changed?
  before_update :delete_kitchen_manager, :if => :kitchen_manager_changed?
  before_update :delete_house_manager, :if => :house_manager_changed?
  before_update :delete_service_manager, :if => :service_manager_changed?
  before_update :delete_scholarship_manager, :if => :scholarship_manager_changed?

  after_update :add_organization_manager, :if => :organization_manager_changed?
  after_update :add_kitchen_manager, :if => :kitchen_manager_changed?
  after_update :add_user_manager, :if => :user_manager_changed?
  after_update :add_house_manager, :if => :house_manager_changed?
  after_update :add_service_manager, :if => :service_manager_changed?
  after_update :add_scholarship_manager, :if => :scholarship_manager_changed?

  private

  # Functions that delete no longer valid roles
  def delete_organization_manager
    UserRole.where(user_id: self.organization_manager_was).where(role_id: 2).destroy_all
  end

  def delete_user_manager
    UserRole.where(:user_id => self.user_manager_was).where(:role_id => 3).delete_all
  end

  def delete_kitchen_manager
    UserRole.where(user_id: self.kitchen_manager_was).where(role_id: 4).destroy_all
  end

  def delete_service_manager
    UserRole.where(user_id: self.service_manager_was).where(role_id: 5).destroy_all
  end

  def delete_scholarship_manager
    UserRole.where(user_id: self.scholarship_manager_was).where(role_id: 6).destroy_all
  end

  def delete_house_manager
    UserRole.where(user_id: self.house_manager_was).where(role_id: 7).destroy_all
  end


  def add_organization_manager
    UserRole.create(:user_id => self.organization_manager, :role_id => 2)
  end

  def add_user_manager
    UserRole.create(:user_id => self.user_manager, :role_id => 3)
  end

  def add_kitchen_manager
    UserRole.create(:user_id => self.kitchen_manager, :role_id => 4)
  end

  def add_service_manager
    UserRole.create(:user_id => self.service_manager, :role_id => 5)
  end

  def add_scholarship_manager
    UserRole.create(:user_id => self.scholarship_manager, :role_id => 6)
  end

  def add_house_manager
    UserRole.create(:user_id => self.house_manager, :role_id => 7)
  end
end

releases/20170422152552/releases/20170420035837/app/controllers/organizations_controller.rb
class OrganizationsController < ApplicationController
  before_action :authorize_action

  def new
    @organization = Organization.new
  end

  def edit
    @organization = Organization.find(params[:id])
  end

  def create
    @organization = Organization.new(organization_params)

    if @organization.save
      redirect_to @organization
    else
      render 'new'
    end
  end

  def update
    @organization = Organization.find(params[:id])

    if @organization.update(organization_params)
      redirect_to @organization
    else
      render 'edit'
    end
  end

  def index
    @organizations = policy_scope(Organization).all.order(:id)
  end

  def show
    @organization = Organization.find(params[:id])
  end

  def destroy
    Organization.find(params[:id]).delete

    redirect_to organizations_path
  end

  private

  def organization_params
    params.require(:organization).permit(
      :full_name,
      :abbreviation,
      :school,
      :address,
      :organization_manager,
      :user_manager,
      :kitchen_manager,
      :house_manager,
      :service_manager,
      :scholarship_manager
    )
  end

  def authorize_action
    authorize Organization
  end
end

releases/20170422152552/releases/20170420035837/app/helpers/organizations_helper.rb
module OrganizationsHelper
end

releases/20170422152552/releases/20170420035837/app/views/organizations/_form.html.erb
<%= form_for @organization do |f| %>

  <% if @organization.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@organization.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @organization.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= f.label :full_name %><br>
    <%= f.text_field :full_name, class: 'form-control' %>
  </div>

  <div class="form-group">
    <%= f.label :abbreviation %><br>
    <%= f.text_field :abbreviation, class: 'form-control' %>
  </div>

  <div class="form-group">
    <%= f.label :school %><br>
    <%= f.text_field :school, class: 'form-control' %>
  </div>

  <div class="form-group">
    <%= f.label :address %><br>
    <%= f.text_area :address, class: 'form-control' %>
  </div>

  <div class="form-group">
    <%= f.label :organization_manager %><br>
    <%= f.collection_select( :organization_manager, User.all, :id, :full_name, {}, {:class=>'form-control'}) %>
  </div>

  <div>
    <%= f.submit 'Submit', :class => 'btn btn-default' %>
  </div>

<% end %>

releases/20170422152552/releases/20170420035837/app/views/organizations/_roles_table.html.erb
<% if policy(:organization).edit?%>
<%= form_for @organization do |f| %>

<% if @organization.errors.any? %>
	<div id="error_explanation">
		<h2>
			<%= pluralize(@organization.errors.count, "error") %> prohibited
			this article from being saved:
		</h2>
		<ul>
			<% @organization.errors.full_messages.each do |msg| %>
				<li><%= msg %></li>
			<% end %>
		</ul>
	</div>
<% end %>

<table class="table table-bordered">
  <tr>
    <th>Role</th>
    <th>Member</th>
  </tr>
  <tr>
    <td>User Manager</td>
    <td><%= f.collection_select( :user_manager, User.where(affiliated_organization: @organization.id), :id, :full_name, {prompt: "User Manager", :selected => (@organization.user_manager)}, {:class=>'form-control'}) %></td>
  </tr>
  <tr>
    <td>Kitchen Manager</td>
    <td><%= f.collection_select( :kitchen_manager, User.where(affiliated_organization: @organization.id), :id, :full_name, {prompt: "Kitchen Manager", :selected => ( @organization.kitchen_manager)}, {:class=>'form-control'}) %></td>
  </tr>
  <tr>
    <td>House Manager</td>
    <td><%= f.collection_select( :house_manager, User.where(affiliated_organization: @organization.id), :id, :full_name, {prompt: "House Manager", :selected => ( @organization.house_manager)}, {:class=>'form-control'}) %></td>
  </tr>
  <tr>
    <td>Service Manager</td>
    <td><%= f.collection_select( :service_manager, User.where(affiliated_organization: @organization.id), :id, :full_name, {prompt: "Service Manager", :selected => ( @organization.service_manager)}, {:class=>'form-control'}) %></td>
  </tr>
  <tr>
    <td>Scholarship Manager</td>
    <td><%= f.collection_select( :scholarship_manager, User.where(affiliated_organization: @organization.id), :id, :full_name, {prompt: "Scholarship Manager", :selected => ( @organization.scholarship_manager)}, {:class=>'form-control'}) %></td>
  </tr>
</table>
<%= f.submit 'Update Managers', :class => 'btn btn-default' %>
<% end %>
<% else %>
<table class="table table-bordered">
  <tr>
    <th>Role</th>
    <th>Member</th>
  </tr>
  <tr>
    <td>User Manager</td>
    <td><%= @organization.user_manager ? User.find(@organization.user_manager).full_name : "--" %></td>
  </tr>
  <tr>
    <td>Kitchen Manager</td>
    <td><%= @organization.kitchen_manager ? User.find(@organization.kitchen_manager).full_name : "--" %></td>
  </tr>
  <tr>
    <td>House Manager</td>
    <td><%= @organization.house_manager ? User.find(@organization.house_manager).full_name : "--" %></td>
  </tr>
  <tr>
    <td>Service Manager</td>
    <td><%= @organization.service_manager ? User.find(@organization.service_manager).full_name : "--" %></td>
  </tr>
  <tr>
    <td>Scholarship Manager</td>
    <td><%= @organization.scholarship_manager ? User.find(@organization.scholarship_manager).full_name : "--" %></td>
  </tr>
</table>
<% end %>

releases/20170422152552/releases/20170420035837/app/views/organizations/edit.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <h1>Editing Organization</h1>
    <%= render 'form' %>
</div>

<%= render 'layouts/footer' %>

releases/20170422152552/releases/20170420035837/app/views/organizations/index.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <div style="text-align:left;">
    <h1>Organization List
      <span style="float:right;">
        <%= link_to "New Organization", new_organization_path(), :class => "btn btn-primary" %>
      </span>
    </h1>
      <table class="table">
      <tr>
        <th>Organization</th>
        <th>Full Name</th>
        <th>School</th>
        <th>Address</th>
        <th>Manager</th>
        <th>Actions</th>
      </tr>
      <% @organizations.each do |organization| %>
        <tr>
          <td><%= organization.id %></td>
          <td><%= organization.full_name %></td>
          <td><%= organization.school %></td>
          <td><%= organization.address %></td>
          <td><%= organization.manager_name || "You need to define a manager"%></td>
          <td class="btn-group" role="group" aria-label="...">
            <%= link_to "Show", organization_path(organization), :class => "btn btn-primary" %>
            <%= link_to "Edit", edit_organization_path(organization), :class => "btn btn-success" %>
            <%= link_to "Delete", organization_path(organization),  method: :delete, :class => "btn btn-danger", data: { confirm: 'Delete organization? You probably dont want to do this.' } %>
          </td>
        </tr>
      <% end %>
  </table>
</div>

<%= render 'layouts/footer' %>

releases/20170422152552/releases/20170420035837/app/views/organizations/new.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <h1>New Organization<span style="float:right;"><%= link_to "Back to Organization List", organizations_path(), :class => "btn btn-primary" %></span></h1>
    <%= render 'form' %>
</div>

<%= render 'layouts/footer' %>

releases/20170422152552/releases/20170420035837/app/views/organizations/show.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">

  <div style="text-align:left;">
    <div class="row">
      <div class="col-md-6">
        <h1>
          <%= @organization.full_name %>
        </h1>
        <div>
          <p>
            <strong>Abbreviation:</strong>
            <%= @organization.abbreviation %>
          </p>
          <p>
            <strong>School:</strong>
            <%= @organization.school %>
          </p>
          <p>
            <strong>Address:</strong>
            <%= @organization.address %>
          </p>
          <p>
            <strong>Org Manager:</strong>
            <%= @organization.manager_name %>
          </p>
        </div>
      </div>
      <div class="col-md-6">
        <%= render 'organizations/roles_table' %>
      </div>
    </div>
    <% if @organization.provisional_members.present? %>
    <h2>
      Provisional Members
      <span style="float:right;">
        <button id="approve_all" class="btn btn-success">Approve All</button>
        <button id="deny_all" class="btn btn-danger">Deny All</button>
      </span>
    </h2>
    <table class="table">
      <tr>
        <th></th>
        <th>Name</th>
        <th>Email Address</th>
        <th>Phone Number</th>
        <th>Actions</th>
      </tr>
      <% @organization.provisional_members.each do |user| %>
        <tr>
          <td><%= image_tag user.image, class: 'img-circle', size: '32' %></td>
          <td><%= user.full_name %></td>
          <td><%= user.email_address %></td>
          <td><%= user.phone_number %></td>
          <td class="btn-group" role="group" aria-label="...">
            <%= link_to "Approve", user_organization_enable_path(user.id, enabled: true), method: :put, :class =>"provisional_approve btn btn-success" %>
            <%= link_to "Deny", user_organization_disable_path(user.id, affiliated_organization: nil), method: :put, :class => "provisional_deny btn btn-danger"%>
          </td>
        </tr>
      <% end %>
    </table>
    <% end %>
    <h2>
      Organization Members
    </h2>
    <table class="table">
      <tr>
        <th></th>
        <th>Number</th>
        <th>Name</th>
        <th>Email Address</th>
        <th>Phone Number</th>
        <th>Actions</th>
      </tr>
      <% @organization.organization_members.each do |user| %>
        <tr>
          <td><%= image_tag user.image, class: 'img-circle', size: '32' %></td>
          <td><%= user.number %></td>
          <td><%= user.full_name %></td>
          <td><%= user.email_address %></td>
          <td><%= user.phone_number %></td>
          <td class="btn-group" role="group" aria-label="...">
            <%= link_to "Show", user_path(user), :class => "btn btn-primary" %>
            <%= link_to "Edit", edit_user_path(user), :class => "btn btn-success" %>
            <%= link_to "Remove from Org", user_organization_disable_path(user.id, affiliated_organization: nil),  method: :put, :class => "btn btn-danger", data: { confirm: 'Delete user?' } %>
          </td>
        </tr>
      <% end %>
    </table>
  </div>
</div>


<%= render 'layouts/footer' %>